/* 
 * File:   main.cpp
 * Author: simon
 *
 * Created on 25. Oktober 2009, 03:56
 */

#include <stdlib.h>
#include <iostream>
#include <iomanip>
#include <fstream>
#include <cstring>
#include <vector>
#include "vocabulary.h"
using namespace std;
/*
 * 
 */
struct AnswerType{
    int docID;
    int fileID[10];
};
Vocabulary DB;
FILE* idxFile;
int queriesId[100];
int iQuerie[100];
vector<string> sQueries;
vector<AnswerType> qAnswer[20];
char line[50][100000];
int qN=0;

void loadIndex(char* doc){
    int large=100000;
    int i;
    char line[large];
    fpos_t pos;
    idxFile= fopen(doc,"r+");
    fgetpos (idxFile,&pos);
    char* pointer;
    while(fgets(line,large,idxFile)){
       // fgets(pointer,large,idxFile);
        pointer=strchr(line,' ');
        pointer++;
        i = strcspn (pointer," ");
        pointer[i]='\0';
        DB.add((string)pointer,pos);
        fgetpos( idxFile,&pos);
    }

}
void askQuery(){
    int answer;
    char str[100];
    printf ("Enter your query: ");
    scanf ("%s",str);
    char* pch;
    
    pch = strtok (str," ,.-\n\t\r!\"\"[](){}&%?=:;<>\'\'|#\\/");
    while (pch != NULL)
    {
        answer=DB.find((string)pch);
        if ((answer)>(-1)){
            sQueries.push_back((string)pch);
            queriesId[qN]=answer;
            qN++;
        }
        pch = strtok (NULL, " ,.-\n\t\r!\"\"[](){}&%?=:;<>\'\'|#\\/");
    }

}
int searchMax(){
    int max=0;
    int buf;
    char* pointer;
    for(int i=0;i<qN;i++){
        pointer=strrchr(line[i],' ');
        if (pointer!=NULL){
            pointer++;
            buf = atoi(pointer);
            if(buf>max){
                max=buf;
            }
        
        }
    }
    return max;
}
void loadAnswer(){
    int large=100000;
    char lineBuf[100000];
    for ( int i=0;i<qN;i++){
        fsetpos( idxFile, &DB._words[queriesId[i]].offset);
        fgets(lineBuf,large,idxFile);

        char *pt =strrchr(lineBuf,'\n');
        pt[0]='\0';
        pt=strchr(lineBuf,' ');
        pt++;
        pt=strchr(pt,' ');
        strcpy(line[i],pt);
       
    }
    int max=-1;
    int count=0;
    int docId;
    string str="";
    int files[10];
    AnswerType buf;
    char*pointer;
    while (max!=0){
        max=searchMax();
        buf.docID=max;
        count=0;
        //bool succes=false;
        for(int i=0;i<qN;i++){
            pointer=strrchr(line[i],' ');
            if(pointer!=NULL){
                pointer++;
                docId = atoi(pointer);
                if(docId==max){
                    count++;
                    buf.fileID[count]=i;
                    pointer--;
                    pointer[0]='\0';
                }
            }
        }
        
        qAnswer[count].push_back(buf);
    }

}
void out(){
    int size;
    for(int i=19; i>0; i--){
        size = qAnswer[i].size();
        if(size>0 || i<3){
            for(int j=0; j<size; j++){
                cout <<"in Document " << qAnswer[i][j].docID << " finded:" ;
                for(int k=1; k<=i; k++){
                    cout << " " << sQueries[qAnswer[i][j].fileID[k]];
                }
                cout << endl;
            }
        }
    }
}
int main(int argc, char** argv) {
    cout << "loading database... " <<endl;
    loadIndex(argv[1]);
    cout << "DONE" <<endl;
    askQuery();
    loadAnswer();
    //printf("%s\0",str);
    fclose(idxFile);
    out();
    return (EXIT_SUCCESS);
}

