#include "vocabulary.h"
void Vocabulary::add(const string& newWord, fpos_t newOffset){
    words buf;
    buf.word=newWord;
    buf.offset=newOffset;
    _words.push_back(buf);
}
int Vocabulary::find(const string& sWord){
    int low=0;
    int high=_words.size();
    int middle;
    while(low<high){
        middle=(low+high)/2;
        if (sWord>_words[middle].word){
            low=middle+1;
        }
        else{
            high=middle;
        }
    }
    if (_words[low].word==sWord)
    {
        return low;
    }
    else
    {
        return -1;
    }
}

